package com.quiomputing.cronopartes.actividades;

import android.os.Bundle;
import android.support.v7.app.AppCompatActivity;
import android.view.Menu;
import android.view.MenuItem;
import android.widget.TextView;

import com.quiomputing.cronopartes.R;
import com.quiomputing.cronopartes.bd.TareaBD;
import com.quiomputing.cronopartes.data.Actividad;

/**
 * Created by joaqu on 02/11/2015.
 */
public class EditorActividades extends AppCompatActivity {

    protected Actividad actividad = null;
    protected Long idProyecto = null;
    protected String nombreProyecto = null;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.editor_actividades);
        Bundle extras = getIntent().getExtras();
        if (extras != null) {
            idProyecto = extras.getLong("id_proyecto");
            nombreProyecto = extras.getString("proyecto");
            long id = extras.getLong("id_actividad", -1);
            if (id > -1) {
                TareaBD bd = new TareaBD(this);
                actividad = bd.getActividad(id);
                if (actividad != null) {
                    ((TextView) findViewById(R.id.actividad_editor_nombre)).setText(actividad.getNombre());
                    ((TextView) findViewById(R.id.actividad_editor_descripcion)).setText(actividad.getDescripcion());
                    ((TextView) findViewById(R.id.actividad_editor_descripcion_defecto)).setText(actividad.getDescripcionDefecto());
                    ((TextView) findViewById(R.id.actividad_editor_notas)).setText(actividad.getNotas());
                }
            }
        }
    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        getMenuInflater().inflate(R.menu.menu_edicion_actividad, menu);
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        switch (item.getItemId()) {
            case R.id.accion_cancelar :
                finish();
                return true;
            case R.id.accion_guardar:
                guardar();
                finish();
                return true;
        }
        return super.onOptionsItemSelected(item);
    }

    protected Actividad guardar() {
        if (actividad == null)
            actividad = new Actividad();
        actividad.setIdProyecto(idProyecto);
        actividad.setNombre(((TextView) findViewById(R.id.actividad_editor_nombre)).getText().toString());
        actividad.setDescripcion(((TextView) findViewById(R.id.actividad_editor_descripcion)).getText().toString());
        actividad.setDescripcionDefecto(((TextView) findViewById(R.id.actividad_editor_descripcion_defecto)).getText().toString());
        actividad.setNotas(((TextView) findViewById(R.id.actividad_editor_notas)).getText().toString());
        TareaBD bd = new TareaBD(this);
        bd.guardar(actividad);
        return actividad;
    }
}
