package com.quiomputing.cronopartes.actividades;

import android.os.Bundle;
import android.support.v7.app.AppCompatActivity;
import android.view.Menu;
import android.view.MenuItem;
import android.widget.TextView;

import com.quiomputing.cronopartes.R;
import com.quiomputing.cronopartes.bd.TareaBD;
import com.quiomputing.cronopartes.data.Proyecto;

/**
 * Created by joaqu on 02/11/2015.
 */
public class EditorProyectos extends AppCompatActivity {

    protected Proyecto proyecto = null;
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.editor_proyectos);
        Bundle extras = getIntent().getExtras();
        if (extras != null) {
            long id = extras.getLong("id_proyecto", -1);
            if (id > -1) {
                TareaBD bd = new TareaBD(this);
                proyecto = bd.getProyecto(id);
                if (proyecto != null) {
                    ((TextView) findViewById(R.id.editor_nombre_proyecto)).setText(proyecto.getNombre());
                    ((TextView) findViewById(R.id.editor_descripcion)).setText(proyecto.getDescripcion());
                    ((TextView) findViewById(R.id.editor_encargado)).setText(proyecto.getResponsable());
                    ((TextView) findViewById(R.id.editor_notas)).setText(proyecto.getNotas());
                }
            }
        }
    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        getMenuInflater().inflate(R.menu.menu_edicion_proyecto, menu);
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        switch (item.getItemId()) {
            case R.id.accion_cancelar :
                finish();
                return true;
            case R.id.accion_guardar:
                guardar();
                finish();
                return true;
        }
        return super.onOptionsItemSelected(item);
    }

    protected Proyecto guardar() {
        if (proyecto == null)
            proyecto = new Proyecto();
        proyecto.setNombre(((TextView) findViewById(R.id.editor_nombre_proyecto)).getText().toString());
        proyecto.setDescripcion(((TextView) findViewById(R.id.editor_descripcion)).getText().toString());
        proyecto.setResponsable(((TextView) findViewById(R.id.editor_encargado)).getText().toString());
        proyecto.setNotas(((TextView) findViewById(R.id.editor_notas)).getText().toString());
        TareaBD bd = new TareaBD(this);
        bd.guardar(proyecto);
        return proyecto;
    }
}
