package com.quiomputing.cronopartes.adapter;

import android.content.Context;
import android.content.res.Resources;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.TextView;

import com.quiomputing.cronopartes.R;
import com.quiomputing.cronopartes.data.ItemWithIcon;

import java.util.ArrayList;
import java.util.List;

/**
 * Created by joaqu on 14/11/2015.
 */
public class AdaptadorOperacionesContextuales extends ArrayAdapter<ItemWithIcon> {

	protected static List<ItemWithIcon> items;

	public static List<ItemWithIcon> getItems(Context context) {
		items = new ArrayList<>();
		items.add(new ItemWithIcon(context.getResources().getString(R.string.edit), android.R.drawable.ic_menu_edit));
		items.add(new ItemWithIcon(context.getResources().getString(R.string.close), android.R.drawable.ic_menu_close_clear_cancel));
		items.add(new ItemWithIcon(context.getResources().getString(R.string.delete), android.R.drawable.ic_menu_delete));
		return items;
	}

	public AdaptadorOperacionesContextuales(Context context, int resource, int textViewResourceId) {
		super(context, resource, textViewResourceId, getItems(context));
	}

	public View getView(int position, View convertView, ViewGroup parent) {
		//Use super class to create the View
		View v = super.getView(position, convertView, parent);
		TextView tv = (TextView)v.findViewById(android.R.id.text1);

		//Put the image on the TextView
		tv.setCompoundDrawablesWithIntrinsicBounds(items.get(position).getIcon(), 0, 0, 0);

		//Add margin between image and text (support various screen densities)
		int dp5 = (int) (5 * getContext().getResources().getDisplayMetrics().density + 0.5f);
		tv.setCompoundDrawablePadding(dp5);

		return v;
	}
}
