package com.quiomputing.cronopartes.bd;

import android.content.ContentValues;
import android.content.Context;
import android.database.Cursor;
import android.database.sqlite.SQLiteDatabase;
import android.database.sqlite.SQLiteOpenHelper;

import com.quiomputing.cronopartes.constantes.Constantes;
import com.quiomputing.cronopartes.data.Actividad;
import com.quiomputing.cronopartes.data.Proyecto;
import com.quiomputing.cronopartes.data.Tarea;

import java.text.ParseException;
import java.util.Calendar;
import java.util.Date;

/**
 * Created by joaqu on 07/11/2015.
 */
public class TareaBD extends SQLiteOpenHelper implements Constantes {

	public TareaBD(Context context) {
		super(context, "chronotask", null, 1);
	}

	@Override
	public void onConfigure(SQLiteDatabase db) {
		super.onConfigure(db);
	}

	@Override
	public void onCreate(SQLiteDatabase db) {
		db.execSQL("CREATE TABLE proyecto (_id INTEGER PRIMARY KEY AUTOINCREMENT, " +
			           "nombre TEXT, " +
			           "descripcion INTEGER, " +
			           "estado TEXT," +
			           "encargado TEXT, " +
			           "notas TEXT," +
			           "fechacreacion TEXT default CURRENT_DATE)");

		db.execSQL("CREATE TABLE actividad (_id INTEGER PRIMARY KEY AUTOINCREMENT, " +
			           "nombre TEXT," +
			           "descripcion TEXT," +
			           "id_proyecto INTEGER," +
			           "desctareadefecto TEXT," +
			           "estado TEXT," +
			           "notas TEXT," +
			           "fechacreacion TEXT default CURRENT_DATE)");

		db.execSQL("CREATE TABLE tarea (_id INTEGER PRIMARY KEY AUTOINCREMENT," +
			           "id_proyecto INTEGER," +
			           "id_actividad INTEGER," +
			           "descripcion TEXT," +
			           "fechainicio TEXT," +
			           "fechafin TEXT," +
			           "tiempo INTEGER," +
			           "lugar TEXT)");
		introducirDatos(db);
	}

	private void introducirDatos(SQLiteDatabase db) {
		Proyecto proyecto = new Proyecto();
		proyecto.setNombre("Proyecto 1");
		proyecto.setDescripcion("Proyecto para probar la aplicación");
		proyecto.setResponsable("Juan Fernandez");
		ContentValues values = new ContentValues();
		values.put("nombre", proyecto.getNombre());
		values.put("descripcion", proyecto.getDescripcion());
		values.put("encargado", proyecto.getResponsable());
		values.put("estado", Proyecto.Estado.ABIERTO.toString());
		values.put("notas", proyecto.getNotas());
		long id = db.insert("proyecto", null, values);
		if (id >= 0)
			proyecto.setId(id);

		Actividad actividad = new Actividad();
		actividad.setNombre("Llamadas");
		actividad.setDescripcion("Llamadas Telefónicas");
		actividad.setIdProyecto(proyecto.getId());
		actividad.setDescripcionDefecto("Llamada de asistencia");
		actividad.setNotas("Esta actividad sirve para agrupar todas las llamadas telefónicas");
		values = new ContentValues();
		values.put("nombre", actividad.getNombre());
		values.put("id_proyecto", actividad.getIdProyecto());
		values.put("descripcion", actividad.getDescripcion());
		values.put("desctareadefecto", actividad.getDescripcionDefecto());
		values.put("estado", Actividad.Estado.ABIERTO.toString());
		values.put("notas", actividad.getNotas());
		id = db.insert("actividad", null, values);
		if (id >= 0)
			actividad.setId(id);
		actividad = new Actividad();
		actividad.setNombre("Desplazamientos");
		actividad.setDescripcion("Desplazamientos al cliente");
		actividad.setIdProyecto(proyecto.getId());
		actividad.setDescripcionDefecto("Desplazamiento en coche");
		actividad.setNotas("Esta actividad sirve para agrupar todos los desplazamientos al cliente");
		values = new ContentValues();
		values.put("nombre", actividad.getNombre());
		values.put("id_proyecto", actividad.getIdProyecto());
		values.put("descripcion", actividad.getDescripcion());
		values.put("desctareadefecto", actividad.getDescripcionDefecto());
		values.put("estado", Actividad.Estado.ABIERTO.toString());
		values.put("notas", actividad.getNotas());
		id = db.insert("actividad", null, values);
		if (id >= 0)
			actividad.setId(id);


		proyecto = new Proyecto();
		proyecto.setNombre("Proyecto 2");
		proyecto.setDescripcion("Nuevo proyecto de prueba");
		proyecto.setResponsable("Juan Pérez");
		values = new ContentValues();
		values.put("nombre", proyecto.getNombre());
		values.put("descripcion", proyecto.getDescripcion());
		values.put("encargado", proyecto.getResponsable());
		values.put("estado", Proyecto.Estado.ABIERTO.toString());
		values.put("notas", proyecto.getNotas());
		id = db.insert("proyecto", null, values);
		if (id >= 0)
			proyecto.setId(id);

		actividad = new Actividad();
		actividad.setNombre("Conexión remota");
		actividad.setDescripcion("Conexión remota para solventar incidencias");
		actividad.setIdProyecto(proyecto.getId());
		actividad.setDescripcionDefecto("Conexión remota");
		actividad.setNotas("Esta actividad sirve para agrupar todas las conexiones debida a incidencias");
		values = new ContentValues();
		values.put("nombre", actividad.getNombre());
		values.put("id_proyecto", actividad.getIdProyecto());
		values.put("descripcion", actividad.getDescripcion());
		values.put("desctareadefecto", actividad.getDescripcionDefecto());
		values.put("estado", Actividad.Estado.ABIERTO.toString());
		values.put("notas", actividad.getNotas());
		id = db.insert("actividad", null, values);
		if (id >= 0)
			actividad.setId(id);
		actividad = new Actividad();
		actividad.setNombre("Desarrollos a medida");
		actividad.setDescripcion("Desarrollos de programación a medida");
		actividad.setIdProyecto(proyecto.getId());
		actividad.setDescripcionDefecto("Desarrollo a medida");
		actividad.setNotas("Esta actividad sirve para agrupar todos los desarrollos de programación requeridos por el cliente");
		values = new ContentValues();
		values.put("nombre", actividad.getNombre());
		values.put("id_proyecto", actividad.getIdProyecto());
		values.put("descripcion", actividad.getDescripcion());
		values.put("desctareadefecto", actividad.getDescripcionDefecto());
		values.put("estado", Actividad.Estado.ABIERTO.toString());
		values.put("notas", actividad.getNotas());
		id = db.insert("actividad", null, values);
		if (id >= 0)
			actividad.setId(id);
	}

	@Override
	public void onUpgrade(SQLiteDatabase db, int oldVersion, int newVersion) { }

	//++++++++++++++++++++++++++++++++++++++++++++++++
	// Tabla Proyectos
	//++++++++++++++++++++++++++++++++++++++++++++++++
	public void guardar(Proyecto proyecto) {
		SQLiteDatabase database = getWritableDatabase();
		ContentValues values = new ContentValues();
		values.put("nombre", proyecto.getNombre());
		values.put("descripcion", proyecto.getDescripcion());
		values.put("encargado", proyecto.getResponsable());
		values.put("estado", Proyecto.Estado.ABIERTO.toString());
		values.put("notas", proyecto.getNotas());
		if (proyecto.getId() == null) {
			long id = database.insert("proyecto", null, values);
			if (id >= 0)
				proyecto.setId(id);
		}
		else
			database.update("proyecto", values, "_id = ?", new String[] {String.valueOf(proyecto.getId())});
	}

	public Cursor getProyectosAbiertos() {
		SQLiteDatabase bd = getReadableDatabase();
		return bd.rawQuery("SELECT * FROM proyecto WHERE estado = ?", new String[]{Proyecto.Estado.ABIERTO.toString()});
	}

	public Cursor getProyectosEnEstado(Proyecto.Estado estado) {
		SQLiteDatabase bd = getReadableDatabase();
		return bd.rawQuery("SELECT * FROM proyecto WHERE estado = ?", new String[]{estado.toString()});
	}

	public Proyecto getProyecto(long id) {
		SQLiteDatabase bd = getReadableDatabase();
		Cursor cursor =  bd.rawQuery("SELECT * FROM proyecto WHERE _id = ?", new String[]{String.valueOf(id)});
		if (!cursor.moveToNext()) {
			cursor.close();
			bd.close();
			return null;
		}
		Proyecto proyecto = new Proyecto();
		proyecto.setId(cursor.getLong(cursor.getColumnIndex("_id")));
		proyecto.setNombre(cursor.getString(cursor.getColumnIndex("nombre")));
		proyecto.setDescripcion(cursor.getString(cursor.getColumnIndex("descripcion")));
		proyecto.setResponsable(cursor.getString(cursor.getColumnIndex("encargado")));
		proyecto.setEstado(Proyecto.Estado.valueOf(cursor.getString(cursor.getColumnIndex("estado"))));
		proyecto.setNotas(cursor.getString(cursor.getColumnIndex("notas")));
		cursor.close();
		bd.close();
		return proyecto;
	}

	public void cerrarProyecto(long id) {
		SQLiteDatabase database = getWritableDatabase();
		ContentValues values = new ContentValues();
		values.put("estado", Proyecto.Estado.CERRADO.toString());
		database.update("proyecto", values, "_id = ?", new String[]{String.valueOf(id)});
	}

	public void borrarProyecto(long id) {
		SQLiteDatabase database = getWritableDatabase();
		database.delete("proyecto", "_id =?", new String[] {String.valueOf(id)});
	}

	//++++++++++++++++++++++++++++++++++++++++++++++++
	// Tabla Actividades
    //++++++++++++++++++++++++++++++++++++++++++++++++
	public void guardar(Actividad actividad) {
		ContentValues values = new ContentValues();
		values.put("nombre", actividad.getNombre());
		values.put("id_proyecto", actividad.getIdProyecto());
		values.put("descripcion", actividad.getDescripcion());
		values.put("desctareadefecto", actividad.getDescripcionDefecto());
		values.put("estado", Actividad.Estado.ABIERTO.toString());
		values.put("notas", actividad.getNotas());
		SQLiteDatabase database = getWritableDatabase();
		if (actividad.getId() == null) {
			long id = database.insert("actividad", null, values);
			if (id >= 0)
				actividad.setId(id);
		}
		else
			database.update("actividad", values, "_id = ?", new String[] {String.valueOf(actividad.getId())});
	}

	public Cursor getActividadesAbiertas(Proyecto proyecto) {
		SQLiteDatabase bd = getReadableDatabase();
		return bd.rawQuery("SELECT * FROM actividad WHERE id_proyecto =? AND estado = ?", new String[]{String.valueOf(proyecto.getId()),
		                                                                                               Actividad.Estado.ABIERTO.toString()});
	}

	public Actividad getActividad(long id) {
		SQLiteDatabase bd = getReadableDatabase();
		Cursor cursor =  bd.rawQuery("SELECT * FROM actividad WHERE _id = ?", new String[]{String.valueOf(id)});
		if (!cursor.moveToNext()) {
			cursor.close();
			bd.close();
			return null;
		}
		Actividad actividad = new Actividad();
		actividad.setId(cursor.getLong(cursor.getColumnIndex("_id")));
		actividad.setNombre(cursor.getString(cursor.getColumnIndex("nombre")));
		actividad.setIdProyecto(cursor.getLong(cursor.getColumnIndex("id_proyecto")));
		actividad.setDescripcion(cursor.getString(cursor.getColumnIndex("descripcion")));
		actividad.setDescripcionDefecto(cursor.getString(cursor.getColumnIndex("desctareadefecto")));
		actividad.setEstado(Actividad.Estado.valueOf(cursor.getString(cursor.getColumnIndex("estado"))));
		actividad.setNotas(cursor.getString(cursor.getColumnIndex("notas")));
		cursor.close();
		bd.close();
		return actividad;
	}

	public void cerrarActividad(long id) {
		SQLiteDatabase database = getWritableDatabase();
		ContentValues values = new ContentValues();
		values.put("estado", Proyecto.Estado.CERRADO.toString());
		database.update("actividad", values, "_id = ?", new String[]{String.valueOf(id)});
	}

	public void borrarActividad(long id) {
		SQLiteDatabase database = getWritableDatabase();
		database.delete("actividad", "_id =?", new String[]{String.valueOf(id)});
	}

	public void borrarActividadesDeProyecto(long idProyecto) {
		SQLiteDatabase database = getWritableDatabase();
		database.delete("actividad", "id_proyecto =?", new String[] {String.valueOf(idProyecto)});
	}


	//++++++++++++++++++++++++++++++++++++++++++++++++
	// Tabla Tareas
	//++++++++++++++++++++++++++++++++++++++++++++++++
	public void guardar(Tarea tarea) {
		ContentValues values = new ContentValues();
		values.put("id_proyecto", tarea.getIdProyecto());
		values.put("id_actividad", tarea.getIdActividad());
		values.put("descripcion", tarea.getDescripcion());
		values.put("fechainicio", sdfDB.format(tarea.getFechaInicio()));
		values.put("fechafin", sdfDB.format(tarea.getFechaFin()));
		values.put("tiempo", tarea.getTiempo());
		values.put("lugar", tarea.getLugar());
		SQLiteDatabase database = getWritableDatabase();
		if (tarea.getId() == null) {
			long id = database.insert("tarea", null, values);
			if (id >= 0)
				tarea.setId(id);
		}
		else
			database.update("tarea", values, "_id = ?", new String[] {String.valueOf(tarea.getId())});
	}

	public Tarea getTarea(long id) {
		SQLiteDatabase bd = getReadableDatabase();
		Cursor cursor =  bd.rawQuery("SELECT * FROM tarea WHERE _id = ?", new String[]{String.valueOf(id)});
		if (!cursor.moveToNext()) {
			cursor.close();
			bd.close();
			return null;
		}
		Tarea tarea = new Tarea();
		tarea.setId(cursor.getLong(cursor.getColumnIndex("_id")));
		tarea.setIdProyecto(cursor.getLong(cursor.getColumnIndex("id_proyecto")));
		tarea.setIdActividad(cursor.getLong(cursor.getColumnIndex("id_actividad")));
		tarea.setDescripcion(cursor.getString(cursor.getColumnIndex("descripcion")));
		try {
			tarea.setFechaInicio(sdfDB.parse(cursor.getString(cursor.getColumnIndex("fechainicio"))));
			tarea.setFechaFin(sdfDB.parse(cursor.getString(cursor.getColumnIndex("fechafin"))));
		} catch (ParseException pe) {
			tarea.setFechaInicio(new Date(System.currentTimeMillis()));
			tarea.setFechaFin(new Date(System.currentTimeMillis()));
		}
		tarea.setTiempo(cursor.getLong(cursor.getColumnIndex("tiempo")));
		tarea.setLugar(cursor.getString(cursor.getColumnIndex("lugar")));
		cursor.close();
		bd.close();
		return tarea;
	}

	public Tarea getUltimaTareaDeProyecto(long idProyecto) {
		SQLiteDatabase bd = getReadableDatabase();
		Cursor cursor =  bd.rawQuery("SELECT * FROM tarea WHERE id_proyecto = ? ORDER BY fechafin DESC LIMIT 1",
		                             new String[]{String.valueOf(idProyecto)});
		if (!cursor.moveToNext()) {
			cursor.close();
			bd.close();
			return null;
		}
		Tarea tarea = new Tarea();
		tarea.setId(cursor.getLong(cursor.getColumnIndex("_id")));
		tarea.setIdProyecto(cursor.getLong(cursor.getColumnIndex("id_proyecto")));
		tarea.setIdActividad(cursor.getLong(cursor.getColumnIndex("id_actividad")));
		tarea.setDescripcion(cursor.getString(cursor.getColumnIndex("descripcion")));
		try {
			tarea.setFechaInicio(sdfDB.parse(cursor.getString(cursor.getColumnIndex("fechainicio"))));
			tarea.setFechaFin(sdfDB.parse(cursor.getString(cursor.getColumnIndex("fechafin"))));
		} catch (ParseException pe) {
			tarea.setFechaInicio(new Date(System.currentTimeMillis()));
			tarea.setFechaFin(new Date(System.currentTimeMillis()));
		}
		tarea.setTiempo(cursor.getLong(cursor.getColumnIndex("tiempo")));
		tarea.setLugar(cursor.getString(cursor.getColumnIndex("lugar")));
		cursor.close();
		bd.close();
		return tarea;
	}

	public void borrarTarea(long id) {
		SQLiteDatabase database = getWritableDatabase();
		database.delete("tarea", "_id =?", new String[]{String.valueOf(id)});
	}

	public void borrarTareasDeProyecto(long idProyecto) {
		SQLiteDatabase database = getWritableDatabase();
		database.delete("tarea", "id_proyecto =?", new String[] {String.valueOf(idProyecto)});
	}

	public void borrarTareasDeActividad(long idProyecto, long idActividad) {
		SQLiteDatabase database = getWritableDatabase();
		database.delete("tarea", "id_proyecto = ? AND id_actividad = ?", new String[]{String.valueOf(idProyecto),
		                                                                              String.valueOf(idActividad)});
	}

	public Tarea crearTareaNueva(Actividad actividad) {
		Tarea tarea = new Tarea();
		tarea.setIdProyecto(actividad.getIdProyecto());
		tarea.setIdActividad(actividad.getId());
		tarea.setFechaInicio(new Date(System.currentTimeMillis()));
		tarea.setFechaFin(new Date(System.currentTimeMillis()));
		tarea.setDescripcion(actividad.getDescripcionDefecto());
		guardar(tarea);
		return tarea;
	}

	public Cursor getTareasAgrupadasPorDia(Date fecha) {
		SQLiteDatabase bd = getReadableDatabase();
		StringBuilder sqlcmd = new StringBuilder();
		sqlcmd.append("SELECT p.nombre, a.descripcion desc_actividad, t.descripcion desc_tarea, SUM(t.tiempo) tiempo, t._id ");
		sqlcmd.append("FROM tarea t LEFT JOIN actividad a ON (t.id_actividad = a._id AND t.id_proyecto = a.id_proyecto) ");
		sqlcmd.append("LEFT JOIN proyecto p ON (a.id_proyecto = p._id) ");
		sqlcmd.append("WHERE fechainicio >= ? and fechainicio < ? ");
		sqlcmd.append("GROUP BY p.Nombre, a.descripcion, t.descripcion");
		Calendar calendarDesde = Calendar.getInstance();
		calendarDesde.setTime(fecha);
		calendarDesde.set(Calendar.HOUR, 0);
		calendarDesde.set(Calendar.MINUTE, 0);
		calendarDesde.set(Calendar.SECOND, 0);

		Calendar calendarHasta = Calendar.getInstance();
		calendarHasta.setTime(fecha);
		calendarHasta.set(Calendar.HOUR, 0);
		calendarHasta.set(Calendar.MINUTE, 0);
		calendarHasta.set(Calendar.SECOND, 0);
		calendarHasta.add(Calendar.DAY_OF_MONTH, 1);

		return bd.rawQuery(sqlcmd.toString(), new String[] { sdfDB.format(calendarDesde.getTime()),
		                                                     sdfDB.format(calendarHasta.getTime())});
	}

}
